#pragma once
#include "binfmt/BinaryFormat.h"
#include "fs/VFS.h"
#include "memory/AddressSpace.h"

class ScriptLoader : public BinaryFormatLoader
{
  public:
    Result<bool> sniff() override;
    Result<u64> load(AddressSpace* space) override;

    Result<Vector<String>> cmdline(const String& path, Vector<String> args) override;

    StringView format() const override
    {
        return "script";
    }

    ScriptLoader(SharedPtr<VFS::Inode> inode, int recursion_level);

    static Result<SharedPtr<BinaryFormatLoader>> create(SharedPtr<VFS::Inode> inode, void*, int);

  private:
    Vector<String> m_interpreter_cmdline;
};
