#pragma once
#include "api/Keyboard.h"
#include "fs/devices/DeviceRegistry.h"
#include <luna/Buffer.h>

class KeyboardDevice : public Device
{
  public:
    // Initializer for DeviceRegistry.
    static Result<void> create();

    Result<usize> read(u8*, usize, usize) const override;

    Result<usize> write(const u8*, usize, usize) override;

    static void add_keyboard_event(const moon::KeyboardPacket& packet);

    bool will_block_if_read() const override;

    StringView device_path() const override
    {
        return "kbd";
    }

    virtual ~KeyboardDevice() = default;

  private:
    mutable Buffer m_packet_buffer;

    static SharedPtr<KeyboardDevice> s_keyboard_device;
};
