#pragma once
#include <luna/Attributes.h>
#include <luna/Result.h>
#include <luna/Types.h>

namespace TextConsole
{
    void clear();
    Result<void> putchar(char c);
    void putwchar(wchar_t c);
    void set_foreground(u32 color);
    void set_background(u32 color);
    u32 foreground();
    u32 background();
    void move_to(u32 x, u32 y);
    Result<void> print(const char* str);
    Result<void> write(const char* str, usize len);
    void wprint(const wchar_t* str);
    Result<void> println(const char* str);
    void wprintln(const wchar_t* str);
    Result<usize> printf(const char* format, ...) _format(1, 2);

    u16 rows();
    u16 cols();
}
