/* bits/pstat.h: The process structure and flags for the pstat() system call. */

#ifndef _BITS_PSTAT_H
#define _BITS_PSTAT_H

#include <bits/timespec.h>
#include <sys/types.h>

#define PS_IDLE 1
#define PS_RUNNABLE 2
#define PS_SLEEPING 3
#define PS_WAITING 4
#define PS_ENDED 5

#define PS_FLAG_KRNL 1

struct process
{
    pid_t ps_pid;
    pid_t ps_ppid;
    uid_t ps_uid;
    uid_t ps_euid;
    gid_t ps_gid;
    gid_t ps_egid;
    int ps_state;
    int ps_flags;
    struct timespec ps_time;
    struct timespec ps_ktime;
    struct timespec ps_utime;
    char ps_name[129];
    char ps_cwd[256];
};

#endif
