/* dirent.h: Directory streams interface. */

#ifndef _DIRENT_H
#define _DIRENT_H

#include <sys/types.h>

typedef struct
{
    int _fd;
} DIR;

struct dirent
{
    ino_t d_ino;
    char d_name[129];
};

#ifdef __cplusplus
extern "C"
{
#endif

    DIR* opendir(const char* path);
    DIR* fdopendir(int fd);
    struct dirent* readdir(DIR* stream);
    int closedir(DIR* stream);
    int dirfd(DIR* stream);
    void rewinddir(DIR* stream);

#ifdef __cplusplus
}
#endif

#endif
