/* fcntl.h: File control. */

#ifndef _FCNTL_H
#define _FCNTL_H

#include <bits/atfile.h>
#include <bits/fcntl.h>
#include <bits/open-flags.h>
#include <sys/types.h>

#ifdef __cplusplus
extern "C"
{
#endif

    /* Open a file path and return a file descriptor to it. */
    int open(const char* path, int flags, ...);

    /* Open a file path relative to a file descriptor and return a file descriptor to it. */
    int openat(int dirfd, const char* path, int flags, ...);

    /* Create a file and return a file descriptor to it. */
    int creat(const char* path, mode_t mode);

    /* Perform a file control operation. */
    int fcntl(int fd, int cmd, ...);

#ifdef __cplusplus
}
#endif

#endif
