#!/usr/bin/env bash
set -e

source $(dirname $0)/env.sh

cd $LUNA_ROOT

if [ "$(id -u)" -ne "0" ]
then
    echo "This script must be run under fakeroot."
    exit 1
fi

if [ "$USER" == "root" ]
then
    echo "This script must be run under fakeroot instead of as root."
    exit 1
fi

chown -R root:root base

cmake --install $LUNA_BUILD_DIR

chmod a+s base/usr/bin/su

mkdir -p base/home/selene

mkdir -p base/dev
mkdir -p base/mnt
mkdir -p base/tmp

rm -f base/bin
ln -s usr/bin base/bin
